#!/bin/bash

# ANSI Colors
echoRed() { echo $'\e[0;31m'"$1"$'\e[0m'; }
echoGreen() { echo $'\e[0;32m'"$1"$'\e[0m'; }
echoYellow() { echo $'\e[0;33m'"$1"$'\e[0m'; }

#启动脚本的主目录
PRG="$0"
APP_WRK_HOME=`dirname "$PRG"`/..
APP_WRK_HOME=`cd "$APP_WRK_HOME" && pwd`

#应用名
export APP_NAME=EUREKA-SERVER

psid=0
#检查进程ID
checkpid() {
   if [[ -f $APP_WRK_HOME/bin/$APP_NAME.pid ]]; then
       psid=$(cat $APP_WRK_HOME/bin/$APP_NAME.pid)
       if [[ -n $psid ]] && [[ 0 -eq $(ps -ef |grep $psid |grep -v "grep" |wc -l) ]]; then
	        psid=0
	   fi
   fi
}

#启动进程
dostart() {
   checkpid
   if [[ $psid -ne 0 ]]; then
      echoYellow "warn: $APP_NAME already started! (pid=$psid)"
   else
      export JAVA_OPTS="$JAVA_OPTS -Dlogging.path=$APP_WRK_HOME"
      export JAVA_OPTS="$JAVA_OPTS -server -Djava.net.preferIPv4Stack=true -Duser.timezone=Asia/Shanghai -Dclient.encoding.override=UTF-8 -Dfile.encoding=UTF-8 -Djava.security.egd=file:/dev/./urandom"
      export JAVA_OPTS="$JAVA_OPTS -XX:+HeapDumpOnOutOfMemoryError"
      export JAVA_OPTS="$JAVA_OPTS -Xms512m -Xmx2048m"
	    export JAVA_OPTS="$JAVA_OPTS -Dlogging.file=$APP_WRK_HOME/logs/application.log"

      BOOT_JAR=`echo $APP_WRK_HOME/*.jar`
      nohup java $JAVA_OPTS -jar $BOOT_JAR > /dev/null 2>&1 &
      echo "$!" > $APP_WRK_HOME/bin/$APP_NAME.pid
      
      sleep 2
      
      checkpid
      if [[ $psid -ne 0 ]]; then
         echoGreen "$APP_NAME successful started! (pid=$psid)"
      else
         echoRed "$APP_NAME started failed!"
      fi
   fi
}

dostart
exit 0